From 44916933444a335d3037088b7a446e378320b101 Mon Sep 17 00:00:00 2001
From: Stephen Higgs <s.j.higgs@gmail.com>
Date: Mon, 28 Jan 2019 15:39:21 -0500
Subject: [PATCH] ENTESB-10074 reproducer

---
 pom.xml                                       |  2 +-
 .../OSGI-INF/blueprint/blueprint.xml          |  3 +-
 src/main/resources/wsdl/HelloWorld.wsdl       | 53 +++++++++++++++++++
 src/main/resources/wsdl/HelloWorldTypes.xsd   | 19 +++++++
 4 files changed, 75 insertions(+), 2 deletions(-)
 create mode 100644 src/main/resources/wsdl/HelloWorld.wsdl
 create mode 100644 src/main/resources/wsdl/HelloWorldTypes.xsd

diff --git a/pom.xml b/pom.xml
index 726f8c6..7301709 100644
--- a/pom.xml
+++ b/pom.xml
@@ -27,7 +27,7 @@
 
     <groupId>org.jboss.quickstarts.fuse</groupId>
     <artifactId>cxf-soap</artifactId>
-    <version>6.3.0.redhat-371</version>
+    <version>6.3.0.redhat-371-SNAPSHOT</version>
     <packaging>bundle</packaging>
     <name>JBoss Fuse Quickstart: soap</name>
     <description>SOAP example using JAXWS</description>
diff --git a/src/main/resources/OSGI-INF/blueprint/blueprint.xml b/src/main/resources/OSGI-INF/blueprint/blueprint.xml
index d32c9b9..02bb778 100644
--- a/src/main/resources/OSGI-INF/blueprint/blueprint.xml
+++ b/src/main/resources/OSGI-INF/blueprint/blueprint.xml
@@ -52,7 +52,8 @@
     -->
     <jaxws:endpoint id="helloWorld"
                     implementor="io.fabric8.quickstarts.soap.HelloWorldImpl"
-                    address="/HelloWorld">
+                    address="/HelloWorld"
+                    wsdlLocation="wsdl/HelloWorld.wsdl">
     </jaxws:endpoint>
 
 </blueprint>
diff --git a/src/main/resources/wsdl/HelloWorld.wsdl b/src/main/resources/wsdl/HelloWorld.wsdl
new file mode 100644
index 0000000..21a4d1e
--- /dev/null
+++ b/src/main/resources/wsdl/HelloWorld.wsdl
@@ -0,0 +1,53 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<wsdl:definitions xmlns:xsd="http://www.w3.org/2001/XMLSchema"
+                  xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
+                  xmlns:tns="http://soap.quickstarts.fabric8.io/"
+                  xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
+                  name="HelloWorldImplService"
+                  targetNamespace="http://soap.quickstarts.fabric8.io/">
+
+	<wsdl:types>
+		<xsd:schema>
+			<xsd:import namespace="http://soap.quickstarts.fabric8.io/"
+			            schemaLocation="HelloWorldTypes.xsd"/>
+		</xsd:schema>
+	</wsdl:types>
+
+	<wsdl:message name="sayHiResponse">
+		<wsdl:part element="tns:sayHiResponse" name="parameters">
+		</wsdl:part>
+	</wsdl:message>
+	<wsdl:message name="sayHi">
+		<wsdl:part element="tns:sayHi" name="parameters">
+		</wsdl:part>
+	</wsdl:message>
+
+	<wsdl:portType name="HelloWorld">
+		<wsdl:operation name="sayHi">
+			<wsdl:input message="tns:sayHi" name="sayHi">
+			</wsdl:input>
+			<wsdl:output message="tns:sayHiResponse" name="sayHiResponse">
+			</wsdl:output>
+		</wsdl:operation>
+	</wsdl:portType>
+
+	<wsdl:binding name="HelloWorldImplServiceSoapBinding" type="tns:HelloWorld">
+		<soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
+		<wsdl:operation name="sayHi">
+			<soap:operation soapAction="" style="document"/>
+			<wsdl:input name="sayHi">
+				<soap:body use="literal"/>
+			</wsdl:input>
+			<wsdl:output name="sayHiResponse">
+				<soap:body use="literal"/>
+			</wsdl:output>
+		</wsdl:operation>
+	</wsdl:binding>
+
+	<wsdl:service name="HelloWorldImplService">
+		<wsdl:port binding="tns:HelloWorldImplServiceSoapBinding" name="HelloWorldImplPort">
+			<soap:address location="http://localhost:9000/cxf/HelloWorld/"/>
+		</wsdl:port>
+	</wsdl:service>
+
+</wsdl:definitions>
\ No newline at end of file
diff --git a/src/main/resources/wsdl/HelloWorldTypes.xsd b/src/main/resources/wsdl/HelloWorldTypes.xsd
new file mode 100644
index 0000000..cba2fba
--- /dev/null
+++ b/src/main/resources/wsdl/HelloWorldTypes.xsd
@@ -0,0 +1,19 @@
+<?xml version='1.0' encoding='UTF-8'?>
+<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
+           xmlns:tns="http://soap.quickstarts.fabric8.io/"
+           targetNamespace="http://soap.quickstarts.fabric8.io/" version="1.0">
+
+	<xs:element name="sayHi" type="tns:sayHi"/>
+	<xs:element name="sayHiResponse" type="tns:sayHiResponse"/>
+	<xs:complexType name="sayHi">
+		<xs:sequence>
+			<xs:element minOccurs="0" name="arg0" type="xs:string"/>
+		</xs:sequence>
+	</xs:complexType>
+	<xs:complexType name="sayHiResponse">
+		<xs:sequence>
+			<xs:element minOccurs="0" name="return" type="xs:string"/>
+		</xs:sequence>
+	</xs:complexType>
+
+</xs:schema>
\ No newline at end of file
-- 
2.20.1